<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { VForm } from 'vuetify/lib/components/index.mjs'
import { user, loginData } from '../../types/User'
import type { User } from '../../types/User'
import PromotionView from '@/views/checkInOut/PromotionView.vue'

const form = ref<InstanceType<typeof VForm> | null>(null)
const valid = ref(true)
const Email = ref('')
const Password = ref('')
const users = ref<User[]>(user)
const timeValue = ref<string | null>(null)
const status = ref('woking')

const titles = ref('')
const statusWorking = ref('')

const onCheck = () => {
  status.value = '1'
  console.log('Formatted Date:', formattedDate.value)
  titles.value = 'Check in'
  Email.value = ''
  Password.value = ''
}

const onCheckOut = () => {
  status.value = '0'
  titles.value = 'Check out'
  Email.value = ''
  Password.value = ''
}
const formattedDate = ref<string>('')
const formatDate = (date: Date): string => {
  const options: Intl.DateTimeFormatOptions = {
    year: 'numeric',
    month: '2-digit',
    day: '2-digit',
    hour: 'numeric',
    minute: 'numeric',
    second: 'numeric',
    hour12: false
  }
  return date.toLocaleDateString('en-US', options)
}
const hoursDifference = ref()
const login = async () => {
  const { valid } = await form.value!.validate()
  let date1 = new Date()
  let date2 = new Date()

  if (valid) {
    for (let i = 0; i < users.value.length; i++) {
      const currentUser = users.value[i]

      if (currentUser.email === Email.value && currentUser.password === Password.value) {
        if (status.value === '1') {
          const exampleDate = new Date()
          formattedDate.value = formatDate(exampleDate)
          currentUser.timein = status.value === '1' ? formattedDate.value! : ''
          date1 = new Date()
          statusWorking.value = 'Working'
          console.log(date1)
        } else if (status.value === '0') {
          const exampleDate = new Date()
          formattedDate.value = formatDate(exampleDate)
          // currentUser.timeout = status.value === '0' ? formattedDate.value! : ''//main
          const dateString = 'Tue Jan 17 2024 19:00:00 GMT+0700 (Indochina Time)' //test
          const date2 = new Date(dateString)
          formattedDate.value = formatDate(date2) //test
          currentUser.timeout = status.value === '0' ? formattedDate.value! : ''

          // const date2 = new Date();
          statusWorking.value = 'Finish'
          console.log(date2)

          const differenceInMinutes = date2.getTime() - date1.getTime()

          hoursDifference.value = Math.round(differenceInMinutes / 3600000)
          currentUser.timework = hoursDifference.value
        }

        loginData.value = loginData.value.filter((user) => user.id !== currentUser.id)
        if (currentUser.timein != '' && currentUser.timein != null) {
          loginData.value.push({
            id: currentUser.id,
            fullName: currentUser.fullName,
            roles: currentUser.roles,
            timein: status.value === '1' ? formattedDate.value || '' : currentUser.timein || '',
            email: currentUser.email,
            password: currentUser.password,
            gender: currentUser.gender,
            timeout: status.value === '1' ? '' : currentUser.timeout || '',
            timework: status.value === '1' ? 0 : currentUser.timework,
            status: statusWorking.value
          })
        } else {
          alert('Please check in first.')
        }

        status.value = '0'
        Email.value = ''
        Password.value = ''
        form.value!.reset()
        console.log(loginData)
        break
      }
    }
  }
}
</script>

<template>
  <div id="app" class="d-flex justify-center">
    <v-card
      variant="tonal"
      width="100%"
      min-width="500"
      max-width="1200"
      max-height="600"
      min-height="750"
      class="ma-3 bg-teal-darken-4"
      :elevation="18"
    >
      <v-card variant="tonal" class="ma-2 bg-teal-darken-4">
        <div
          style="
            background-color: rgb(0, 0, 0);
            color: aliceblue;
            text-align: center;
            font-size: 50px;
            font-family: Arial, Helvetica, sans-serif;
          "
        >
          Working Attendance
        </div>
        <v-container>
          <v-dialog transition="dialog-top-transition" width="auto">
            <template v-slot:activator="{ props }">
              <v-btn color="green" v-bind="props" @click="onCheck">Check in</v-btn>
              <v-btn v-bind="props" class="ma-2" @click="onCheckOut" color="error">Check out</v-btn>
            </template>
            <template v-slot:default="{ isActive }">
              <v-card>
                <v-toolbar color="green" :title="titles"></v-toolbar>
                <v-card-text style="width: 500px">
                  <v-form ref="form" v-model="valid">
                    <v-text-field
                      label="Email"
                      required
                      hide-details
                      v-model="Email"
                    ></v-text-field>
                    <v-text-field
                      label="Password"
                      required
                      hide-details
                      type="Password"
                      v-model="Password"
                      icon="mdi-checkbox-marked-circle"
                    ></v-text-field>
                  </v-form>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn variant="text" @click="isActive.value = false" color="error">Close</v-btn>

                  <v-btn
                    variant="text"
                    color="success"
                    @click="
                      () => {
                        isActive.value = false
                        login()
                      }
                    "
                    >Submit</v-btn
                  >
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>

          <div class="d-flex justify-center">
            <v-card min-width="500" max-width="1200" height="auto" elevation="6">
              <v-table fixed-header height="550px" style="overflow: auto; width: 2000px">
                <thead>
                  <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">Name</th>
                    <th class="text-center">Role</th>
                    <th class="text-center">Time in</th>
                    <th class="text-center">Time out</th>
                    <th class="text-center">Time work</th>
                    <th class="text-center">Status</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="user in loginData" :key="user.id">
                    <td class="text-center">{{ user.id }}</td>
                    <td class="text-center">{{ user.fullName }}</td>
                    <td class="text-center">{{ user.roles.join(', ') }}</td>
                    <td class="text-center">{{ user.timein }}</td>
                    <td class="text-center">{{ user.timeout }}</td>
                    <td class="text-center">{{ user.timework }}</td>
                    <td class="text-center" style="color: rgb(255, 0, 0)">{{ user.status }}</td>
                  </tr>
                </tbody>
              </v-table>
            </v-card>
          </div>
        </v-container>
      </v-card>
    </v-card>
  </div>

  <PromotionView></PromotionView>
</template>

<style scoped>
#app {
  background-color: #212121;
  height: 100%;
}
</style>
